﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재 Form을 MainForm으로 설정합니다.
        SmartForm1.MainForm = Me
    End Sub

    Private Sub rad_Ko_Click(ByVal sender As Object, ByVal e As EventArgs) Handles rad_Ko.Click
        ' UI의 Text를 한글로 변경하기 위해 [한글 Resource]를 선택합니다.
        SmartStringResource.SelectResource(My.Resources.Resource_Ko.ResourceManager)
        ' 선택한 Resource를 적용하기 위해 UI 언어 변경을 진행합니다.
        UILanguageChange()
    End Sub

    Private Sub rad_En_Click(ByVal sender As Object, ByVal e As EventArgs) Handles rad_En.Click
        ' UI의 Text를 영어로 변경하기 위해 [영어 Resource]를 선택합니다.
        SmartStringResource.SelectResource(My.Resources.Resource_EN.ResourceManager)
        ' 선택한 Resource를 적용하기 위해 UI 언어 변경을 진행합니다.
        UILanguageChange()
    End Sub

    ' 선택한 Resource에서 UI에 맞는 Text를 가져오기 위한 메소드
    Private Sub UILanguageChange()
        ' ※ 화면에서 언어가 변경되었을 때 표시되어야 하는 요소들에 대해서는 모두 아래와 같이 설정을 해주어야 합니다.
        ' ※ 또한 여러 개의 Form을 사용하는 MDI 구조에서는 언어가 변경되어야 하는 각 Form에서 아래와 같은 설정이 수행되도록 처리가 필요합니다.

        ' Resource에서 “Form1_XX”라는 Name을 가지고 있는 Value를 가져와 각 UI의 Text로 설정
        smartLabel1.Text = SmartStringResource.GetString("Form1_smartLabel1")

        smartRadioButton1.Text = SmartStringResource.GetString("Form1_smartRadioButton1")
        smartRadioButton2.Text = SmartStringResource.GetString("Form1_smartRadioButton2")
        smartRadioButton3.Text = SmartStringResource.GetString("Form1_smartRadioButton3")
        smartRadioButton4.Text = SmartStringResource.GetString("Form1_smartRadioButton4")

        smartButton1.ButtonText = SmartStringResource.GetString("Form1_smartButton1")

        smartCheckBox1.Text = SmartStringResource.GetString("Form1_smartCheckBox1")
        smartCheckBox2.Text = SmartStringResource.GetString("Form1_smartCheckBox2")
        smartCheckBox3.Text = SmartStringResource.GetString("Form1_smartCheckBox3")
    End Sub
End Class

' 다국어 사용을 위한 Resource 언어 변환 클래스
Public Class SmartStringResource
    Private Shared g_SelectResourceManager As System.Resources.ResourceManager

    Public Shared Sub SelectResource(ByVal selResource As System.Resources.ResourceManager)
        ' 생성한 언어 Resource에 대한 접근을 위해 선택한 Resource의 ResourceManager를 등록
        g_SelectResourceManager = selResource
    End Sub

    Public Shared Function GetString(ByVal strName As String) As String
        ' 선택한 Resource 중 strName으로 설정되어 있는 Name의 Value값을 가져오기
        Return g_SelectResourceManager.GetString(strName)
    End Function
End Class
